#include "hgDatum.h"
#include "_hgDatumData.h"

#include <iostream>
#include <iomanip.h>
#include <time.h>

//=============================================================================
//=============================================================================
hgDatum::hgDatum ()
{
  data = new hgDatumData();

  if (data)
  {
    time_t  timer;
    struct tm *tblock;

    timer        = time(NULL);
    tblock       = localtime(&timer);
    data->nTag   = tblock->tm_mday;
    data->nMonat = tblock->tm_mon + 1;
    data->nJahr  = tblock->tm_year + 1900;
  }
}

//=============================================================================
//=============================================================================
hgDatum::~hgDatum ()
{
  if (data)
  {
    delete data;
    data = NULL;
  }
}

//=============================================================================
//=============================================================================
int hgDatum::getTag ()
{
  if (data)
  {
    return data->nTag;
  }
  return 0;
}

//=============================================================================
//=============================================================================
int hgDatum::getMonat ()
{
  if (data)
  {
    return data->nMonat;
  }
  return 0;
}

//=============================================================================
//=============================================================================
int hgDatum::getJahr ()
{
  if (data)
  {
    return data->nJahr;
  }
  return 0;
}

//=============================================================================
//=============================================================================
void hgDatum::setTag (int pTag)
{
  if (data)
  {
    data->nTag = pTag;
  }
}

//=============================================================================
//=============================================================================
void hgDatum::setMonat (int pMonat)
{
  if (data)
  {
    data->nMonat = pMonat;
  }
}

//=============================================================================
//=============================================================================
void hgDatum::setJahr (int pJahr)
{
  if (data)
  {
    data->nJahr = pJahr;
  }
}

//=============================================================================
//=============================================================================
ostream & operator<< (ostream & os, hgDatum & d)
{
  char buffer = os.fill('0');

  os << setw(2) << d.getTag()   << "."
     << setw(2) << d.getMonat() << "."
     << setw(4) << d.getJahr();
  os.fill(buffer);
  return os;
}
